VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   5595
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9825
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5595
   ScaleWidth      =   9825
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Read Taskmanager ListView"
      Height          =   405
      Left            =   30
      TabIndex        =   1
      Top             =   5160
      Width           =   9765
   End
   Begin MSComctlLib.ListView ListView1 
      Height          =   5085
      Left            =   30
      TabIndex        =   0
      Top             =   30
      Width           =   9765
      _ExtentX        =   17224
      _ExtentY        =   8969
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Starten Sie zuerst den Taskmanager von Windows und wechseln
' Sie dann auf die Registerkarte "Prozesse". Klicken Sie dann
' auf den Button "Read Taskmanager ListView".

Private Sub Form_Load()

    Me.ScaleMode = vbPixels
    
End Sub

Private Sub Command1_Click()

    Dim hListView As Long
    
    ' Handle des SysListView32 im Taskmanager ermitteln
    hListView = FindTaskmanagerListView
    
    ' ist ein Handle vorhanden
    If hListView <> 0 Then
    
        ' ListView auslesen
        Call ReadFromListView(hListView)
        
    End If
    
End Sub

' SysListView32 des Taskmanager finden
Private Function FindTaskmanagerListView() As Long

    Dim lngWnd0 As Long
    Dim lngWnd1 As Long
    Dim lngWnd2 As Long
    Dim lngWnd3 As Long
    Dim lngWnd4 As Long
    
    lngWnd0 = FindWindow("#32770", "Windows Task-Manager")
    
    If lngWnd0 <> 0 Then
    
        lngWnd1 = FindWindowEx(lngWnd0, 0&, "#32770", vbNullString)
        
        If lngWnd1 <> 0 Then
        
            lngWnd2 = FindWindowEx(lngWnd1, 0&, "SysListView32", _
                "Prozesse")
                
            If lngWnd2 <> 0 Then
            
                FindTaskmanagerListView = lngWnd2
                
            End If
        End If
    End If
    
End Function

' ListView auslesen
Private Sub ReadFromListView(ByVal hListViewWnd As Long)

    Dim xItem As ListItem
    Dim xColumn As ColumnHeader
    Dim lngCol As Long
    Dim lngRow As Long
    Dim lngColCount As Long
    Dim lngRowCount As Long
    Dim lngItem As Long
    Dim lngHeader As Long
    
    ' alle Items lschen
    ListView1.ListItems.Clear
    ListView1.ColumnHeaders.Clear
    
    ' Reportansicht
    ListView1.View = lvwReport
    
    ' Handle des ListView-Headers ermitteln
    lngHeader = SendMessage(hListViewWnd, LVM_GETHEADER, 0, 0)
    
    ' ist ein Handle vorhanden
    If lngHeader <> 0 Then
    
        ' Anzahl der Headerelemente (Spalten) auslesen
        lngColCount = SendMessage(lngHeader, HDM_GETITEMCOUNT, 0&, 0&)
        
        ' alle Headerelemente durchlaufen
        For lngItem = 0 To lngColCount - 1
        
            ' Header anlegen
            Set xColumn = ListView1.ColumnHeaders.Add(, , _
                GetHeaderItemString(lngHeader, lngItem))
                
            ' Columnbreite auslesen und fr unsere ListView setzen
            xColumn.Width = SendMessage(hListViewWnd, LVM_GETCOLUMNWIDTH, _
                lngItem, 0)
                
        Next lngItem
        
    End If
    
    ' Anzahl der ListView-Elemente (Zeilen) auslesen
    lngRowCount = SendMessage(hListViewWnd, LVM_GETITEMCOUNT, 0&, 0&)
    
    ' alle Zeilen durchlaufen
    For lngRow = 0 To lngRowCount - 1
    
        ' alle Spalten durchlaufen
        For lngCol = 0 To lngColCount - 1
        
            ' Spalte 0
            If lngCol = 0 Then
            
                ' Item in der ListView anlegen
                Set xItem = ListView1.ListItems.Add(, , _
                    GetListViewItemString(hListViewWnd, lngRow, lngCol))
                    
            Else
            
                ' SubItems ausfllen
                xItem.SubItems(lngCol) = GetListViewItemString( _
                    hListViewWnd, lngRow, lngCol)
                    
            End If
            
        Next lngCol
    Next lngRow
    
End Sub

